#include <iostream>
#include <fstream>
#include <string>

static const size_t WINDOW_WIDTH_OFFSET = 0x00014CC7;
static const size_t WINDOW_HEIGHT_OFFSET = 0x00014CD1;

template <typename T>
void patch(std::ofstream& executable, size_t offset, const T& value)
{
	executable.seekp(offset, std::ofstream::beg);
	executable.write(reinterpret_cast<const char*>(&value), sizeof(T));
	executable.flush();
}

int main() {
	std::ofstream executable("LgStones.exe", std::ofstream::in | std::ofstream::out | std::ofstream::binary);

	if (executable) {
		std::cout << "Width of the game window: ";

		std::string width_str;
		std::getline(std::cin, width_str);

		uint32_t width = std::stoi(width_str);
		uint32_t height = uint32_t(width / 4.0f * 3.0f);

		std::cout << "Height of the game window: " << height << std::endl;

		patch<uint32_t>(executable, WINDOW_WIDTH_OFFSET, width);
		patch<uint32_t>(executable, WINDOW_HEIGHT_OFFSET, height);

		std::cout << "Done!" << std::endl;
	}
	else {
		std::cerr << "Couldn't find LgStones.exe!" << std::endl;
	}

	system("pause");
	return 0;
}